#!/usr/bin/env

import time
import json
import sys
import pprint
from sonic_platform import platform

print "============================ NEW API REPORT ============================="
# currently force the chassis.PORT_INFO_PATH to point to mocked sysfs
# Need to update it back after finish the test!


mock_sysfs_path = "/var/run/redis/SFF/"
mock_sysfs_isr = "{parent}/{port}/{ptype}_isr_flags"

# Set port event
event_data = "0x11"
port_events_emulate = [
  {
    "name": "SFP1",
    "type": "sfp",
    "event_data": event_data
  },
  {
    "name": "SFP2",
    "type": "sfp",
    "event_data": event_data
  },
  {
    "name": "QSFP1",
    "type": "qsfp",
    "event_data": event_data
  },
  {
    "name": "QSFP2",
    "type": "qsfp",
    "event_data": event_data
  }
]

def test_event_timeout(timeout_ms, port_event_list=[]):

    uut_platform = None
    uut_chassis = None

    if timeout_ms == 0:
        print "TEST:WAIT EVENT FOREVER"
    else:
        print "TEST: WAIT EVENT TIMEOUT", timeout_ms, "msec"

    if len(port_event_list) is 0:
        print "No interrupt event set"
    else:
        print "Set interrupt event on:"
    try:
        # setup
        for evt in port_event_list:
            print(evt["name"])
            sysfs_isr_file = mock_sysfs_isr.format(
                parent=mock_sysfs_path,
                port=evt["name"],
                ptype=evt["type"])
            with open(sysfs_isr_file, 'w') as fd:
                fd.write(str(evt["event_data"]))

        # Run event test
        uut_platform = platform.Platform()
        uut_chassis = uut_platform.get_chassis()

        start = time.time()
        status, events = uut_chassis.get_change_event(timeout_ms)
        elapsed = time.time() - start
        pprint.pprint(events)
        print "get_change_event() elasped time:", round(elapsed, 6), "sec"

    except IOError:
        print("IOError")

    finally:

        for evt in port_event_list:
            sysfs_isr_file = mock_sysfs_isr.format(
                parent=mock_sysfs_path,
                port=evt["name"],
                ptype=evt["type"])
            with open(sysfs_isr_file, 'w') as fd:
                fd.write("0x00")
            sleep(0.1)

def main():
    # Test port event emulated
    test_event_timeout(5*1000, port_events_emulate)
    test_event_timeout(0.5*1000, port_events_emulate)
    test_event_timeout(0, port_events_emulate)

    # Test no port event
    test_event_timeout(5*1000)
    test_event_timeout(0.5*1000)

    # This will wait forever until we inject the event signal
    test_event_timeout(0)

if __name__ == '__main__':
    main()